#ifndef _LBBCSAMPLECONFIGFILE_H
#define _LBBCSAMPLECONFIGFILE_H

#include <BBC.h>

namespace LBBC {

class _BBCExport SampleConfigFile : public Ogre::ConfigFile {
  public:
    SampleConfigFile();
	
    virtual ~SampleConfigFile();

	Ogre::String getEntitySampleMaterialName();

	bool getEntityDistributionMerged();

	Ogre::String getEntityDistributionSplittedMeshName();

	Ogre::String getEntityDistributionSplittedMaterialName();

	Ogre::String getEntityDistributionMergedMeshName();

	Ogre::String getEntityDistributionMergedMaterialName();

	bool getEntityDistributionSplitted();

	Ogre::String getEntitySampleMeshName();

	bool getEntityDistributionGeneration();

	Ogre::String getEntityDistributionFolder();

	Ogre::String getEntityDistributionXMLName();

	Ogre::String getEntitiesFolder();

	bool getEntitySampleMeshGeneration();

	Ogre::String getEntitiesMeshName();

	bool getEntityClustersGeneration();

	float getEntityClustersAlpha();

	unsigned int getEntityClustersMaxClusters();

	unsigned int getEntityClustersNumIterations();

	Ogre::String getEntityClustersFolder();

	bool getEntityClustersSplittedClusters();

	bool getEntityClustersGroupedClusters();

	bool getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasDebug();

	bool getBillboardCloudIndirectGroupedBillboardsTextureAtlasDebug();

	Ogre::String getEntityClustersGroupedMeshName();

	Ogre::String getEntityClustersSplittedMeshName();

	Ogre::String getEntityClustersGroupedMaterialName();

	Ogre::String getEntityClustersSplittedMaterialName();

	Ogre::String getEntityClustersGroupedTextureUnit0Name();

	Ogre::String getEntityClustersSplittedTextureUnit0Name();

	bool getBillboardCloudGroupedIndirectTexturingDiffuseBillboards();

	bool getBillboardCloudGroupedDiffuseBillboards();

	bool getBillboardCloudGroupedDiffuseColorBillboards(); 

	unsigned int getBillboardCloudGroupedDiffuseColorGroups();

	bool getBillboardCloudSplittedBillboards();

	Ogre::String getBillboardCloudFolder();

	Ogre::String getBillboardCloudGroupedDiffuseColorMeshName();

	Ogre::String getBillboardCloudGroupedIndirectTexturingMeshName();

	Ogre::String getBillboardCloudSplittedMeshName();

	Ogre::String getBillboardCloudGroupedDiffuseColorMaterialName();

	Ogre::String getBillboardCloudSplittedMaterialName();

	Ogre::String getBillboardCloudGroupedIndirectTexturingMaterialName();

	Ogre::String getBillboardCloudSplittedTextureUnit0Name();

	Ogre::String getBillboardCloudGroupedDiffuseColorTextureUnit0Name();

	Ogre::String getBillboardCloudGroupedIndirectTexturingTextureUnit0Name();

	Ogre::String getBillboardCloudGroupedIndirectTexturingXMLName();

	Ogre::String getBillboardCloudSplittedXMLName();

	Ogre::String getBillboardCloudGroupedDiffuseColorXMLName();

	Ogre::String getBillboardCloudIndirectPointMeshName();

	Ogre::String getBillboardCloudIndirectPointMaterialName();

	unsigned int getBillboardCloudGroupedIndirectTexturingGroups();

	bool getBillboardCloudGroupedIndirectTexturingBillboards();

	bool getBillboardCloudDiffuseColorEntityTextureAtlasGeneration();

	Ogre::String getBillboardCloudDiffuseColorEntityTextureName();

	Ogre::String getBillboardCloudDiffuseColorEntityTextureAtlasName();	

	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasBitRange();

	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasSize();

	unsigned int getBillboardCloudDiffuseColorGroupedBillboardsTextureSize();

	bool getBillboardCloudIndirectGroupedBillboardsTextureAtlasGeneration();

	Ogre::String getBillboardCloudIndirectGroupedBillboardsTextureAtlasName();

	unsigned int getBillboardCloudIndirectGroupedBillboardsTextureAtlasBitRange();

	unsigned int getBillboardCloudIndirectGroupedBillboardsTextureAtlasSize();

	unsigned int getBillboardCloudIndirectGroupedBillboardsTextureSize();

	bool getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasGeneration();

    unsigned int getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasSize();

	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasNumSamples();

	Ogre::String getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasName();

	unsigned int getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasBitRange();

};

}

#endif